#include "sys.h"
#include "dcmi.h" 
#include "lcd.h" 
#include "led.h" 
#include "ov2640.h" 
#include <string.h> 

u8 ov_frame=0;  						//֡
extern u16 Parallel_Data_Buffer1[38400] ;
extern u16 Parallel_Data_Buffer2[38400] ;
extern int zhencount;
extern u16 display[76800];
DCMI_InitTypeDef DCMI_InitStructure;

//DCMIжϷ
void DMA2_Stream1_IRQHandler(void)//DMA2_Stream1_IRQHandler DCMI_IRQHandler
{
	long i=0;
 if(DMA_GetITStatus(DMA2_Stream1,DMA_IT_TCIF1) != RESET)
	{
		DMA_ClearITPendingBit(DMA2_Stream1,DMA_IT_TCIF1);
	  zhencount++; //ͼֶα־2
		if(zhencount==1)
		{
			i=0;
			while(i< 38400)
			{
				if(Parallel_Data_Buffer1[i]>0x7fff)
				{
					display[i]=	0xffff;
				}
				else
				{
					display[i]=	0x0000;
				}
				i++;				
			}
		}
		if(zhencount==2)
		{
			zhencount=0;
			i=0;
			while(i< 38400)
			{
				if(Parallel_Data_Buffer2[i]>0x7fff) //0x7fff is the threshold value,you can change it.

				{
					display[38400+i]=	0xffff;
				}
				else
				{
					display[38400+i]=	0x0000;
				}
				i++;				
			}
		}
		for(i=0;i<76800;i++)
		{
				LCD_WriteRAM(display[i]);
		}	 
	}
} 

//DCMIжϷ
/**/
void DCMI_IRQHandler(void)
{
	if(DCMI_GetITStatus(DCMI_IT_FRAME)==SET)//һ֡ͼ
	{
		DCMI_ClearITPendingBit(DCMI_IT_FRAME);//֡ж  
		DMA_ITConfig(DMA2_Stream1, DMA_IT_TC, ENABLE);
		DCMI_ITConfig(DCMI_IT_FRAME,DISABLE);
	} 	 
	
} 


//DCMI DMA
//DMA_Memory0BaseAddr:洢ַ    Ҫ洢ͷݵڴַ(Ҳַ)
//DMA_BufferSize:洢    0~65535
//DMA_MemoryDataSize:洢λ  
//DMA_MemoryDataSize:洢λ    @defgroup DMA_memory_data_size :DMA_MemoryDataSize_Byte/DMA_MemoryDataSize_HalfWord/DMA_MemoryDataSize_Word
//DMA_MemoryInc:洢ʽ  @defgroup DMA_memory_incremented_mode  /** @defgroup DMA_memory_incremented_mode : DMA_MemoryInc_Enable/DMA_MemoryInc_Disable
void DCMI_DMA_Init(u32 DMA_Memory0BaseAddr,u16 DMA_BufferSize,u32 DMA_MemoryDataSize,u32 DMA_MemoryInc)
{ 
	DMA_InitTypeDef  DMA_InitStructure;
	
  RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_DMA2,ENABLE);//DMA2ʱʹ 
	DMA_DeInit(DMA2_Stream1);
	while (DMA_GetCmdStatus(DMA2_Stream1) != DISABLE){}//ȴDMA2_Stream1 
	
  /*  DMA Stream */
  DMA_InitStructure.DMA_Channel = DMA_Channel_1;  //ͨ1 DCMIͨ 
  DMA_InitStructure.DMA_PeripheralBaseAddr = (u32)&DCMI->DR;//ַΪ:DCMI->DR
  DMA_InitStructure.DMA_Memory0BaseAddr = DMA_Memory0BaseAddr;//DMA 洢0ַ
  DMA_InitStructure.DMA_DIR = DMA_DIR_PeripheralToMemory;//赽洢ģʽ
  DMA_InitStructure.DMA_BufferSize = DMA_BufferSize;//ݴ 
  DMA_InitStructure.DMA_PeripheralInc = DMA_PeripheralInc_Disable;//ģʽ
  DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc;//洢ģʽ
  DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_Word;//ݳ:32λ
  DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize;//洢ݳ 
  DMA_InitStructure.DMA_Mode = DMA_Mode_Circular;// ʹѭģʽ 
  DMA_InitStructure.DMA_Priority = DMA_Priority_High;//ȼ
  DMA_InitStructure.DMA_FIFOMode = DMA_FIFOMode_Enable; //FIFOģʽ        
  DMA_InitStructure.DMA_FIFOThreshold = DMA_FIFOThreshold_Full;//ʹȫFIFO 
  DMA_InitStructure.DMA_MemoryBurst = DMA_MemoryBurst_Single;//ͻδ
  DMA_InitStructure.DMA_PeripheralBurst = DMA_PeripheralBurst_Single;//洢ͻδ
  DMA_Init(DMA2_Stream1, &DMA_InitStructure);//ʼDMA Stream
	
	DMA_DoubleBufferModeConfig(DMA2_Stream1,(u32)Parallel_Data_Buffer1,DMA_Memory_0);
  DMA_DoubleBufferModeCmd(DMA2_Stream1,ENABLE);        //?????
	DMA_Cmd(DMA2_Stream1, ENABLE);
	DMA_ITConfig(DMA2_Stream1, DMA_IT_TC, ENABLE);
} 
//DCMIʼ
void My_DCMI_Init(void)
{
  GPIO_InitTypeDef  GPIO_InitStructure;
	NVIC_InitTypeDef NVIC_InitStructure;

	
  RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOA|RCC_AHB1Periph_GPIOB|RCC_AHB1Periph_GPIOC|RCC_AHB1Periph_GPIOE, ENABLE);//ʹGPIOA B C E ʱ
	RCC_AHB2PeriphClockCmd(RCC_AHB2Periph_DCMI,ENABLE);//ʹDCMIʱ
  //PA4/6ʼ
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_4|GPIO_Pin_6;//PA4/6   ù
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF; //ù
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;//
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;//100MHz
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;//
  GPIO_Init(GPIOA, &GPIO_InitStructure);//ʼ
	
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_7|GPIO_Pin_6;// PB6/7   ù
  GPIO_Init(GPIOB, &GPIO_InitStructure);//ʼ
	
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6|GPIO_Pin_7|GPIO_Pin_8|GPIO_Pin_9|GPIO_Pin_11;//PC6/7/8/9/11 ù
  GPIO_Init(GPIOC, &GPIO_InitStructure);//ʼ	

  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5|GPIO_Pin_6;//PE5/6  ù 
  GPIO_Init(GPIOE, &GPIO_InitStructure);//ʼ	

	GPIO_PinAFConfig(GPIOA,GPIO_PinSource4,GPIO_AF_DCMI); //PA4,AF13  DCMI_HSYNC
	GPIO_PinAFConfig(GPIOA,GPIO_PinSource6,GPIO_AF_DCMI); //PA6,AF13  DCMI_PCLK  
 	GPIO_PinAFConfig(GPIOB,GPIO_PinSource7,GPIO_AF_DCMI); //PB7,AF13  DCMI_VSYNC 
 	GPIO_PinAFConfig(GPIOC,GPIO_PinSource6,GPIO_AF_DCMI); //PC6,AF13  DCMI_D0  
 	GPIO_PinAFConfig(GPIOC,GPIO_PinSource7,GPIO_AF_DCMI); //PC7,AF13  DCMI_D1 
	GPIO_PinAFConfig(GPIOC,GPIO_PinSource8,GPIO_AF_DCMI); //PC8,AF13  DCMI_D2
	GPIO_PinAFConfig(GPIOC,GPIO_PinSource9,GPIO_AF_DCMI); //PC9,AF13  DCMI_D3
	GPIO_PinAFConfig(GPIOC,GPIO_PinSource11,GPIO_AF_DCMI);//PC11,AF13 DCMI_D4 
	GPIO_PinAFConfig(GPIOB,GPIO_PinSource6,GPIO_AF_DCMI); //PB6,AF13  DCMI_D5 
	GPIO_PinAFConfig(GPIOE,GPIO_PinSource5,GPIO_AF_DCMI); //PE5,AF13  DCMI_D6
	GPIO_PinAFConfig(GPIOE,GPIO_PinSource6,GPIO_AF_DCMI); //PE6,AF13  DCMI_D7

	
	DCMI_DeInit();//ԭ 
 
 
  DCMI_InitStructure.DCMI_CaptureMode=DCMI_CaptureMode_Continuous;//ģʽ
	DCMI_InitStructure.DCMI_CaptureRate=DCMI_CaptureRate_All_Frame;//ȫ֡
	DCMI_InitStructure.DCMI_ExtendedDataMode= DCMI_ExtendedDataMode_8b;//8λݸʽ  
	DCMI_InitStructure.DCMI_HSPolarity= DCMI_HSPolarity_Low;//HSYNC ͵ƽЧ
	DCMI_InitStructure.DCMI_PCKPolarity= DCMI_PCKPolarity_Rising;//PCLK Ч
	DCMI_InitStructure.DCMI_SynchroMode= DCMI_SynchroMode_Hardware;//ӲͬHSYNC,VSYNC
	DCMI_InitStructure.DCMI_VSPolarity=DCMI_VSPolarity_Low;//VSYNC ͵ƽЧ
	DCMI_Init(&DCMI_InitStructure);

	//DCMI_ITConfig(DCMI_IT_FRAME,ENABLE);//֡ж 
	
	DCMI_Cmd(ENABLE);	//DCMIʹ

  NVIC_InitStructure.NVIC_IRQChannel = DCMI_IRQn;
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority=1;//ռȼ1
	NVIC_InitStructure.NVIC_IRQChannelSubPriority =2;		//ȼ3
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;			//IRQͨʹ
	NVIC_Init(&NVIC_InitStructure);	//ָĲʼVICĴ



  NVIC_InitStructure.NVIC_IRQChannel = DMA2_Stream1_IRQn;//DCMI_IRQn;
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority=1;//ռȼ1
	NVIC_InitStructure.NVIC_IRQChannelSubPriority =3;		//ȼ3
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;			//IRQͨʹ
	NVIC_Init(&NVIC_InitStructure);	//ָĲʼVICĴ
  
	
} 
//DCMI,
void DCMI_Start(void)
{  
  LCD_SetCursor(0,0);  
	LCD_WriteRAM_Prepare();		//ʼдGRAM
	DMA_Cmd(DMA2_Stream1, ENABLE);//DMA2,Stream1 
	DCMI_CaptureCmd(ENABLE);//DCMIʹ  
}
//DCMI,رմ
void DCMI_Stop(void)
{ 
  DCMI_CaptureCmd(DISABLE);//DCMIʹر	
	
	while(DCMI->CR&0X01);		//ȴ 
	 	
	DMA_Cmd(DMA2_Stream1,DISABLE);//رDMA2,Stream1
} 
////////////////////////////////////////////////////////////////////////////////
//,usmart,ڵԴ

//DCMIʾ
//sx,sy;LCDʼ
//width,height:LCDʾΧ.
void DCMI_Set_Window(u16 sx,u16 sy,u16 width,u16 height)
{
	DCMI_Stop(); 
	LCD_Clear(WHITE);
	LCD_Set_Window(sx,sy,width,height);
	OV2640_OutSize_Set(width,height);
  LCD_SetCursor(0,0);  
	LCD_WriteRAM_Prepare();		//ʼдGRAM
	
	DMA_Cmd(DMA2_Stream1,ENABLE);	//DMA2,Stream1 
	
	DCMI_CaptureCmd(ENABLE);//DCMIʹ 
	
}
   
//ͨusmart,.
//pclk/hsync/vsync:źŵ޵ƽ
void DCMI_CR_Set(u8 pclk,u8 hsync,u8 vsync)
{
	DCMI_DeInit();//ԭ 
 
  DCMI_InitStructure.DCMI_CaptureMode=DCMI_CaptureMode_Continuous;//ģʽ
	DCMI_InitStructure.DCMI_CaptureRate=DCMI_CaptureRate_All_Frame;//ȫ֡
	DCMI_InitStructure.DCMI_ExtendedDataMode= DCMI_ExtendedDataMode_8b;//8λݸʽ  
	DCMI_InitStructure.DCMI_HSPolarity= hsync<<6;//HSYNC ͵ƽЧ
	DCMI_InitStructure.DCMI_PCKPolarity= pclk<<5;//PCLK Ч
	DCMI_InitStructure.DCMI_SynchroMode= DCMI_SynchroMode_Hardware;//ӲͬHSYNC,VSYNC
	DCMI_InitStructure.DCMI_VSPolarity=vsync<<7;//VSYNC ͵ƽЧ
	DCMI_Init(&DCMI_InitStructure);

	DCMI_CaptureCmd(ENABLE);//DCMIʹ 
	DCMI_Cmd(ENABLE);	//DCMIʹ
  
}








