#include "timer.h"
#include "led.h"
#include "usart.h"

extern u8 ov_frame;
extern volatile u16 jpeg_data_len;


//ͨöʱ3жϳʼ
//arrԶװֵ
//pscʱԤƵ
//ʱʱ㷽:Tout=((arr+1)*(psc+1))/Ft us.
//Ft=ʱƵ,λ:Mhz
//ʹõǶʱ3!
void TIM3_Int_Init(u16 arr,u16 psc)
{
	TIM_TimeBaseInitTypeDef TIM_TimeBaseInitStructure;
	NVIC_InitTypeDef NVIC_InitStructure;
	
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM3,ENABLE);  ///ʹTIM3ʱ
	
	TIM_TimeBaseInitStructure.TIM_Prescaler=psc;  //ʱƵ
	TIM_TimeBaseInitStructure.TIM_CounterMode=TIM_CounterMode_Up; //ϼģʽ
	TIM_TimeBaseInitStructure.TIM_Period=arr;   //Զװֵ
	TIM_TimeBaseInitStructure.TIM_ClockDivision=TIM_CKD_DIV1; 
	
	TIM_TimeBaseInit(TIM3,&TIM_TimeBaseInitStructure);
	
	TIM_ITConfig(TIM3,TIM_IT_Update,ENABLE); //ʱ3ж
	TIM_Cmd(TIM3,ENABLE); //ʹܶʱ3
	
	NVIC_InitStructure.NVIC_IRQChannel=TIM3_IRQn; //ʱ3ж
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority=0x01; //ռȼ1
	NVIC_InitStructure.NVIC_IRQChannelSubPriority=0x03; //ȼ3
	NVIC_InitStructure.NVIC_IRQChannelCmd=ENABLE;
	NVIC_Init(&NVIC_InitStructure);
	
}

//ʱ3жϷ
void TIM3_IRQHandler(void)
{
	if(TIM_GetITStatus(TIM3,TIM_IT_Update)==SET) //ж
	{
		printf("frame:%d\r\n",ov_frame);//ӡ֡
		printf("jpeg_data_len:%d\r\n",jpeg_data_len);//ӡ֡
		ov_frame=0;
	}
	TIM_ClearITPendingBit(TIM3,TIM_IT_Update);  //жϱ־λ
}
